package com.winhc.phoenix.example.controller;

import com.winhc.phoenix.example.service.HbaseQueryService;
import com.winhc.phoenix.example.vo.HbaseQueryParamVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * @author: XuJiakai
 * 2021/1/26 10:23
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("fast")
@Api(tags = "可高并发的查询接口", value = "fast")
public class FastQueryController {
    private final HbaseQueryService hbaseQueryService;


    @ApiOperation(value = "批量获取人名")
    @PostMapping("hbase/bulk-get/human")
    public Object bulkGet(@RequestBody String[] rowkey) {
        return hbaseQueryService.humanBulkGet(rowkey);
    }

    @ApiOperation(value = "批量查询hbase，并可指定字段")
    @PostMapping("hbase/bulk-get")
    public Object fastGetHbase(@RequestParam String tableName, @RequestBody HbaseQueryParamVo hbaseQueryParamVo) {
        return hbaseQueryService.fastGetHbase(tableName, hbaseQueryParamVo);
    }

}
