package com.winhc.phoenix.example.service.impl;

import com.aliyun.openservices.ons.api.Message;
import com.aliyun.openservices.ons.api.Producer;
import com.aliyun.openservices.ons.api.SendResult;
import com.winhc.phoenix.example.service.SmsService;
import com.winhc.phoenix.example.vo.SmsBean;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author: XuJiakai
 * 2020/10/31 10:54
 */
@Slf4j
@Service
@AllArgsConstructor
public class SmsServiceImpl implements SmsService {
    private final Producer producer;

    @Override
    public boolean send(String msg, String to) {
        return send(msg, new String[]{to});
    }

    @Override
    public boolean send(String bean) {
        Message message = new Message("test_sendmsg", "tag_ymt", bean.getBytes());
        SendResult sendResult = producer.send(message);
        assert sendResult != null;
        return true;

    }

    @Override
    public boolean send(String msg, String[] to) {
        return send(new SmsBean(to, msg).toString());
    }
}
