package com.winhc.phoenix.example.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2020/12/7 13:57
 */
public class HighlightUtils {
    public static String append(String source, String highlight) {
        String replace = highlight.replace("<font color='red'>", "\001").replace("</font>", "\002").replace("\002\001", "");
        int sourceIndex = 0;
        char[] ghc = replace.toCharArray();
        int highIndex = 0;
        char[] chars = source.toCharArray();
        List<Character> res = new ArrayList<>();
        for (char c : ghc) {
            res.add(c);
        }
        int delta = 0;
        int pretotal = -1;
        int total = 0;
        while (sourceIndex < chars.length && highIndex < ghc.length) {
            pretotal = total;
            total = sourceIndex + highIndex;
            if (pretotal != 0 && pretotal == total) {
                ++sourceIndex;
                ++highIndex;
                continue;
            }

            if (ghc[highIndex] == chars[sourceIndex] || (ghc[highIndex] + "").equals(chars[sourceIndex] + "")) {
                sourceIndex++;
                highIndex++;
                continue;
            }
            if (chars[sourceIndex] == '(' || chars[sourceIndex] == ')') {
                if (ghc[highIndex] == '\001') {
                    if (findLeft(ghc, highIndex)) {
                        res.add(highIndex + delta, chars[sourceIndex]);

                    } else {
                        res.add(highIndex + delta + 1, chars[sourceIndex]);

                    }
                } else {
                    res.add(highIndex + delta, chars[sourceIndex]);
                }
                delta++;
                sourceIndex++;
            }
            if (ghc[highIndex] == '\001' || ghc[highIndex] == '\002') {
                highIndex++;
            }
        }
        String replace1 = res.stream().map(String::valueOf).collect(Collectors.joining())
                .replace("(\001", "\001(")
                .replace("\002)", ")\002")
                .replace("\002\001", "")
                .replace("\001", "<font color=\"red\">")
                .replace("\002", "</font>");

        Map<String, String> collect = source.chars().mapToObj(s -> String.valueOf((char) s)).distinct().collect(Collectors.toMap(s -> s, s -> s, (o, n) -> n));

        if (collect.isEmpty()) {
            return replace1;
        }
        for (Map.Entry<String, String> stringStringEntry : collect.entrySet()) {
            if (stringStringEntry.getValue().equals(stringStringEntry.getKey())) {
                continue;
            }
            replace1 = replace1.replace(stringStringEntry.getValue(), stringStringEntry.getKey());
        }
        return replace1;
    }

    private static boolean findLeft(char[] chars, int index) {
        while (index >= 0) {
            if (chars[index] == '\001') {
                return true;
            }
            if (chars[index] == '\002') {
                return false;
            }
            --index;
        }
        return false;
    }


    public static void main(String[] args) {
        System.out.println(append("百度云智(北京)科技有限公司", "<font color='red'>百度云智</font>北京科技有限公司"));
    }
}
