package com.winhc.phoenix.example.service.impl;

import lombok.SneakyThrows;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.aggregations.Aggregation;
import org.elasticsearch.search.aggregations.AggregationBuilders;
import org.elasticsearch.search.aggregations.bucket.terms.Terms;
import org.elasticsearch.search.aggregations.bucket.terms.TermsAggregationBuilder;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Map;

@SpringBootTest
class SearchServiceImplTest {
    @Autowired
    RestHighLevelClient restHighLevelClient;

    @Test
    void tips() {
//        Object 百度网讯 = searchService.tips("百度网讯");
//        System.out.println(百度网讯);
    }

    @SneakyThrows
    @Test
    void query() {

        TermsAggregationBuilder builder = AggregationBuilders.terms("name").field("human_pid")
                .size(50)
                .order(Terms.Order.aggregation("province_code_f", false))
                .subAggregation(AggregationBuilders.terms("pro").field("province_code").size(2))
                .subAggregation(AggregationBuilders.filter("province_code_f", QueryBuilders.termQuery("province_code", "11")));


        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder()
                .query(QueryBuilders.termQuery("human_name", "马云"))
                .size(0)
                .aggregation(builder);

        SearchRequest searchRequest = new SearchRequest()
                .indices("company-human-relation-v1")
                .types("relation")
                .source(searchSourceBuilder);

        SearchResponse search = restHighLevelClient.search(searchRequest);


        Map<String, Aggregation> stringAggregationMap = search.getAggregations().asMap();
        System.out.println("out");

//        ((ParsedStringTerms) stringAggregationMap.get("name")).getBuckets().stream().collect(Collectors.toMap(MultiBucketsAggregation.Bucket::getKeyAsString, t->t))


        System.out.println(search);
    }
}